import pyray
import sys
from .exports import *

ExportNames('KeyboardKey')
if sys.version_info >= (3, 12):
	exec('type KeyboardKey = pyray.KeyboardKey')
else:
	class KeyboardKey:
		pass

ExportNames('VK_Null', 'VK_Left', 'VK_Up', 'VK_Right', 'VK_Down', 'VK_PageUp', 'VK_PageDown',
	'VK_Home', 'VK_End', 'VK_Insert', 'VK_Delete', 'VK_Enter', 'VK_Back', 'VK_Tab', 'VK_F1',
	'VK_F2', 'VK_F3', 'VK_F4', 'VK_F5', 'VK_F6', 'VK_F7', 'VK_F8', 'VK_F9', 'VK_F10', 'VK_F11',
	'VK_F12', 'VK_Menu', 'VK_Pause', 'VK_CapsLock', 'VK_PrintScreen', 'VK_Space', 'VK_A',
	'VK_B', 'VK_C', 'VK_D', 'VK_E', 'VK_F', 'VK_G', 'VK_H', 'VK_I', 'VK_J', 'VK_K', 'VK_L',
	'VK_M', 'VK_N', 'VK_O', 'VK_P', 'VK_Q', 'VK_R', 'VK_S', 'VK_T', 'VK_U', 'VK_V', 'VK_W',
	'VK_X', 'VK_Y', 'VK_Z', 'VK_LWin', 'VK_RWin', 'VK_NumPad0', 'VK_NumPad1', 'VK_NumPad2',
	'VK_NumPad3', 'VK_NumPad4', 'VK_NumPad5', 'VK_NumPad6', 'VK_NumPad7', 'VK_NumPad8',
	'VK_NumPad9', 'VK_Multiply', 'VK_Add', 'VK_Subtract', 'VK_Decimal', 'VK_Divide',
	'VK_NumLock', 'VK_Scroll', 'VK_LShiftKey', 'VK_RShiftKey', 'VK_LControlKey',
	'VK_RControlKey', 'VK_Escape', 'VK_Backtick', 'VK_1', 'VK_2', 'VK_3', 'VK_4', 'VK_5',
	'VK_6', 'VK_7', 'VK_8', 'VK_9', 'VK_0', 'VK_Minus', 'VK_Equal', 'VK_Backspace',
	'VK_LAltKey', 'VK_RAltKey', 'VK_NumPadEnter', 'VK_NumPadEqual', 'VK_Period')

VK_Null        : KeyboardKey = pyray.KEY_NULL # extra
VK_Left        : KeyboardKey = pyray.KEY_LEFT
VK_Up          : KeyboardKey = pyray.KEY_UP
VK_Right       : KeyboardKey = pyray.KEY_RIGHT
VK_Down        : KeyboardKey = pyray.KEY_DOWN
VK_PageUp      : KeyboardKey = pyray.KEY_PAGE_UP
VK_PageDown    : KeyboardKey = pyray.KEY_PAGE_DOWN
# VK_Prior --- missing
# VK_Next --- missing
VK_Home        : KeyboardKey = pyray.KEY_HOME
VK_End         : KeyboardKey = pyray.KEY_END
VK_Insert      : KeyboardKey = pyray.KEY_INSERT
VK_Delete      : KeyboardKey = pyray.KEY_DELETE
VK_Enter       : KeyboardKey = pyray.KEY_ENTER
# VK_Return --- missing
VK_Back        : KeyboardKey = pyray.KEY_BACK
VK_Tab         : KeyboardKey = pyray.KEY_TAB
# VK_ShiftKey --- missing
# VK_ControlKey --- missing
VK_F1          : KeyboardKey = pyray.KEY_F1
VK_F2          : KeyboardKey = pyray.KEY_F2
VK_F3          : KeyboardKey = pyray.KEY_F3
VK_F4          : KeyboardKey = pyray.KEY_F4
VK_F5          : KeyboardKey = pyray.KEY_F5
VK_F6          : KeyboardKey = pyray.KEY_F6
VK_F7          : KeyboardKey = pyray.KEY_F7
VK_F8          : KeyboardKey = pyray.KEY_F8
VK_F9          : KeyboardKey = pyray.KEY_F9
VK_F10         : KeyboardKey = pyray.KEY_F10
VK_F11         : KeyboardKey = pyray.KEY_F11
VK_F12         : KeyboardKey = pyray.KEY_F12
VK_Menu        : KeyboardKey = pyray.KEY_MENU
VK_Pause       : KeyboardKey = pyray.KEY_PAUSE
VK_CapsLock    : KeyboardKey = pyray.KEY_CAPS_LOCK
# VK_Capital --- missing
VK_PrintScreen : KeyboardKey = pyray.KEY_PRINT_SCREEN
# VK_Help --- missing
VK_Space       : KeyboardKey = pyray.KEY_SPACE
VK_A           : KeyboardKey = pyray.KEY_A
VK_B           : KeyboardKey = pyray.KEY_B
VK_C           : KeyboardKey = pyray.KEY_C
VK_D           : KeyboardKey = pyray.KEY_D
VK_E           : KeyboardKey = pyray.KEY_E
VK_F           : KeyboardKey = pyray.KEY_F
VK_G           : KeyboardKey = pyray.KEY_G
VK_H           : KeyboardKey = pyray.KEY_H
VK_I           : KeyboardKey = pyray.KEY_I
VK_J           : KeyboardKey = pyray.KEY_J
VK_K           : KeyboardKey = pyray.KEY_K
VK_L           : KeyboardKey = pyray.KEY_L
VK_M           : KeyboardKey = pyray.KEY_M
VK_N           : KeyboardKey = pyray.KEY_N
VK_O           : KeyboardKey = pyray.KEY_O
VK_P           : KeyboardKey = pyray.KEY_P
VK_Q           : KeyboardKey = pyray.KEY_Q
VK_R           : KeyboardKey = pyray.KEY_R
VK_S           : KeyboardKey = pyray.KEY_S
VK_T           : KeyboardKey = pyray.KEY_T
VK_U           : KeyboardKey = pyray.KEY_U
VK_V           : KeyboardKey = pyray.KEY_V
VK_W           : KeyboardKey = pyray.KEY_W
VK_X           : KeyboardKey = pyray.KEY_X
VK_Y           : KeyboardKey = pyray.KEY_Y
VK_Z           : KeyboardKey = pyray.KEY_Z
VK_LWin        : KeyboardKey = pyray.KEY_LEFT_SUPER
VK_RWin        : KeyboardKey = pyray.KEY_RIGHT_SUPER
# VK_Apps --- missing
# VK_Sleep --- missing
# VK_LineFeed --- missing
VK_NumPad0     : KeyboardKey = pyray.KEY_KP_0
VK_NumPad1     : KeyboardKey = pyray.KEY_KP_1
VK_NumPad2     : KeyboardKey = pyray.KEY_KP_2
VK_NumPad3     : KeyboardKey = pyray.KEY_KP_3
VK_NumPad4     : KeyboardKey = pyray.KEY_KP_4
VK_NumPad5     : KeyboardKey = pyray.KEY_KP_5
VK_NumPad6     : KeyboardKey = pyray.KEY_KP_6
VK_NumPad7     : KeyboardKey = pyray.KEY_KP_7
VK_NumPad8     : KeyboardKey = pyray.KEY_KP_8
VK_NumPad9     : KeyboardKey = pyray.KEY_KP_9
VK_Multiply    : KeyboardKey = pyray.KEY_KP_MULTIPLY
VK_Add         : KeyboardKey = pyray.KEY_KP_ADD
# VK_Separator --- missing
VK_Subtract    : KeyboardKey = pyray.KEY_KP_SUBTRACT
VK_Decimal     : KeyboardKey = pyray.KEY_KP_DECIMAL
VK_Divide      : KeyboardKey = pyray.KEY_KP_DIVIDE
VK_NumLock     : KeyboardKey = pyray.KEY_NUM_LOCK
VK_Scroll      : KeyboardKey = pyray.KEY_SCROLL_LOCK
VK_LShiftKey   : KeyboardKey = pyray.KEY_LEFT_SHIFT
VK_RShiftKey   : KeyboardKey = pyray.KEY_RIGHT_SHIFT
VK_LControlKey : KeyboardKey = pyray.KEY_LEFT_CONTROL
VK_RControlKey : KeyboardKey = pyray.KEY_RIGHT_CONTROL
# VK_LMenu --- missing
# VK_RMenu --- missing
# VK_KeyCode --- missing
# VK_Shift --- missing
# VK_Control --- missing
# VK_Alt --- missing
# VK_Modifiers --- missing
# VK_Select --- missing
# VK_Print --- missing
# VK_Snapshot --- missing
### Extra keys:
VK_Escape      : KeyboardKey = pyray.KEY_ESCAPE
VK_Backtick    : KeyboardKey = pyray.KEY_GRAVE
VK_1           : KeyboardKey = pyray.KEY_ONE
VK_2           : KeyboardKey = pyray.KEY_TWO
VK_3           : KeyboardKey = pyray.KEY_THREE
VK_4           : KeyboardKey = pyray.KEY_FOUR
VK_5           : KeyboardKey = pyray.KEY_FIVE
VK_6           : KeyboardKey = pyray.KEY_SIX
VK_7           : KeyboardKey = pyray.KEY_SEVEN
VK_8           : KeyboardKey = pyray.KEY_EIGHT
VK_9           : KeyboardKey = pyray.KEY_NINE
VK_0           : KeyboardKey = pyray.KEY_ZERO
VK_Minus       : KeyboardKey = pyray.KEY_MINUS
VK_Equal       : KeyboardKey = pyray.KEY_EQUAL
VK_Backspace   : KeyboardKey = pyray.KEY_BACKSPACE
VK_LAltKey     : KeyboardKey = pyray.KEY_LEFT_ALT
VK_RAltKey     : KeyboardKey = pyray.KEY_RIGHT_ALT
VK_NumPadEnter : KeyboardKey = pyray.KEY_KP_ENTER
VK_NumPadEqual : KeyboardKey = pyray.KEY_KP_EQUAL
VK_Period      : KeyboardKey = pyray.KEY_PERIOD

__all__ = get_local_exports()
